using System;
using System.Security.Permissions;
using System.Security.Principal;



[assembly:SecurityPermission(SecurityAction.RequestMinimum,ControlPrincipal=true)]

namespace Permission
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			String id1 = "bob";
			String role1 = "Manager";
			PrincipalPermission perm1 = new PrincipalPermission(id1,role1);
			
			String id2 = "ERICMITTP08\\Eric Mittelette";
			String role2 = "BUILTIN\\Administrator";
			PrincipalPermission perm2 = new PrincipalPermission(id2,role2,false); //false = connected
			perm2.Demand();
			(perm1.Union(perm2)).Demand();
			Console.WriteLine("perm2 et perm1.Union(perm2) OK");
	
			WindowsIdentity wi = WindowsIdentity.GetCurrent();
			Console.WriteLine(wi.Name);
			Console.WriteLine("Token : " + wi.Token.ToString());
			
			WindowsPrincipal wp = new WindowsPrincipal(wi);

			if (wp.IsInRole(WindowsBuiltInRole.Administrator))
				Console.WriteLine(WindowsBuiltInRole.Administrator.ToString() + " Admin");
			
			if (wp.IsInRole("BUILTIN\\Administrators"))
				Console.WriteLine("BUILTIN\\Administrators : " + wp.ToString());
			
			if (System.Threading.Thread.CurrentPrincipal.IsInRole("BUILTIN\\Administrators"))
				Console.WriteLine("System.Threading.Thread.CurrentPrincipal.IsInRole : Administrator");
			

			
			PrincipalPermission p = new PrincipalPermission(null,"BUILTIN\\Administrator",false);
			Console.WriteLine("IsUnrestricted "  +  p.IsUnrestricted().ToString() );
			p.Demand();
			
			
			
			Console.WriteLine("Demande OK");
		}
	}
}
